"""Constants/functions for AD.

Ripped from:
- ldapper
- ldapdomaindump
- bloodhound.py
"""

from __future__ import annotations

import datetime
import re
import time

from ldap3.protocol.formatters.formatters import format_ad_timestamp


DISTINGUISHED_NAME_PATTERN = re.compile(
    r"(?:CN=(?:[\w\s\-]+),)*(?:OU=(?:[\w\s\-]+),)*(?:DC=(?:[\w\s\-]+),?)+",
    flags=re.IGNORECASE,
)


def unix_to_ldap_timestamp(dt: datetime.datetime) -> str:
    return str(int(time.mktime(dt.timetuple()) * 10000000) + 116444736000000000)


def binary_to_sid(buf: bytes) -> str:
    version = int(buf[0])
    subAuthorityCount = int(buf[1])
    identifierAuthority = int.from_bytes(buf[2:8], "little")
    sidString = f"S-{version}-{subAuthorityCount}"

    for i in range(8, len(buf), 4):
        number = int.from_bytes(buf[i : i + 4], "little")
        sidString += f"-{number}"

    return sidString


# userAccountControl
#
# Source:
# https://learn.microsoft.com/en-us/troubleshoot/windows-server/identity/useraccountcontrol-manipulate-account-properties
#
UAC_FLAGS = {
    0x00000001: "SCRIPT",
    0x00000002: "ACCOUNTDISABLE",
    0x00000008: "HOMEDIR_REQUIRED",
    0x00000010: "LOCKOUT",
    0x00000020: "PASSWD_NOTREQD",
    0x00000040: "PASSWD_CANT_CHANGE",
    0x00000080: "ENCRYPTED_TEXT_PWD_ALLOWED",
    0x00000100: "TEMP_DUPLICATE_ACCOUNT",
    0x00000200: "NORMAL_ACCOUNT",
    0x00000800: "INTERDOMAIN_TRUST_ACCOUNT",
    0x00001000: "WORKSTATION_TRUST_ACCOUNT",
    0x00002000: "SERVER_TRUST_ACCOUNT",
    0x00010000: "DONT_EXPIRE_PASSWD",
    0x00020000: "MNS_LOGON_ACCOUNT",
    0x00040000: "SMARTCARD_REQUIRED",
    0x00080000: "TRUSTED_FOR_DELEGATION",
    0x00100000: "NOT_DELEGATED",
    0x00200000: "USE_DES_KEY_ONLY",
    0x00400000: "DONT_REQ_PREAUTH",
    0x00800000: "PASSWORD_EXPIRED",
    0x01000000: "TRUSTED_TO_AUTH_FOR_DELEGATION",
    0x04000000: "PARTIAL_SECRETS_ACCOUNT",
}

# NOTE: Adding non-hex versions of some dicts as well because libraries don't usually bother with
# hex, and these numbers are too big to bother mentally calculating
#
# TODO: This uses outdated UAC flags, update to match above
#
NON_HEX_UAC_FLAGS = {
    2: "ACCOUNT_DISABLED",
    16: "ACCOUNT_LOCKED",
    32: "PASSWD_NOTREQD",
    64: "PASSWD_CANT_CHANGE",
    # 128: "PASSWORD_STORE_CLEARTEXT",  # Commented out because bad wording, and it's from the dead link
    128: "ENCRYPTED_TEXT_PWD_ALLOWED",
    512: "NORMAL_ACCOUNT",
    4096: "WORKSTATION_ACCOUNT",
    8192: "SERVER_TRUST_ACCOUNT",
    65536: "DONT_EXPIRE_PASSWD",
    262144: "SMARTCARD_REQUIRED",
    524288: "TRUSTED_FOR_DELEGATION",
    1048576: "NOT_DELEGATED",
    2097152: "USE_DES_KEY_ONLY",
    4194304: "DONT_REQ_PREAUTH",
    8388608: "PASSWORD_EXPIRED",
    16777216: "TRUSTED_TO_AUTH_FOR_DELEGATION",
    67108864: "PARTIAL_SECRETS_ACCOUNT",
}

# sAMAccountType
#
# Source:
# https://learn.microsoft.com/en-us/windows/win32/adschema/a-samaccounttype
#
# TODO: Why are there two different constants with the same value...?
#
SAM_ACCOUNT_TYPES = {
    0x0: "SAM_DOMAIN_OBJECT",
    0x10000000: "SAM_GROUP_OBJECT",
    0x10000001: "SAM_NON_SECURITY_GROUP_OBJECT",
    0x20000000: "SAM_ALIAS_OBJECT",
    0x20000001: "SAM_NON_SECURITY_ALIAS_OBJECT",
    # 0x30000000: "SAM_USER_OBJECT",
    0x30000000: "SAM_NORMAL_USER_ACCOUNT",
    0x30000001: "SAM_MACHINE_ACCOUNT",
    0x30000002: "SAM_TRUST_ACCOUNT",
    0x40000000: "SAM_APP_BASIC_GROUP",
    0x40000001: "SAM_APP_QUERY_GROUP",
    0x7FFFFFFF: "SAM_ACCOUNT_TYPE_MAX",
}

NON_HEX_SAM_ACCOUNT_TYPES = {
    0: "SAM_DOMAIN_OBJECT",
    268435456: "SAM_GROUP_OBJECT",
    268435457: "SAM_NON_SECURITY_GROUP_OBJECT",
    536870912: "SAM_ALIAS_OBJECT",
    536870913: "SAM_NON_SECURITY_ALIAS_OBJECT",
    805306368: "SAM_USER_OBJECT",
    # 805306368: "SAM_NORMAL_USER_ACCOUNT",  # alternative name
    805306369: "SAM_MACHINE_ACCOUNT",
    805306370: "SAM_TRUST_ACCOUNT",
    1073741824: "SAM_APP_BASIC_GROUP",
    1073741825: "SAM_APP_QUERY_GROUP",
    2147483647: "SAM_ACCOUNT_TYPE_MAX",
}

# pwdProperties
#
# Source:
# https://learn.microsoft.com/en-us/windows/win32/adschema/a-pwdproperties
# https://winprotocoldoc.blob.core.windows.net/productionwindowsarchives/MS-SAMR/%5bMS-SAMR%5d.pdf
#
PWD_POLICY_FLAGS = {
    # The server enforces password complexity policy.
    0x00000001: "PASSWORD_COMPLEX",
    # Reserved. No effect on password policy.
    0x00000002: "PASSWORD_NO_ANON_CHANGE",
    # Change-password methods that provide the cleartext password are disabled by the server.
    0x00000004: "PASSWORD_NO_CLEAR_CHANGE",
    # Reserved. No effect on password policy.
    0x00000008: "LOCKOUT_ADMINS",
    # The server MUST store the cleartext password, not just the computed hashes.
    0x00000010: "PASSWORD_STORE_CLEARTEXT",
    # Reserved. No effect on password policy.
    0x00000020: "REFUSE_PASSWORD_CHANGE",
}

# trustAttributes
# From: https://msdn.microsoft.com/en-us/library/cc223779.aspx
TRUST_FLAGS = {
    0x00000001: "NON_TRANSITIVE",
    0x00000002: "UPLEVEL_ONLY",
    0x00000004: "QUARANTINED_DOMAIN",
    0x00000008: "FOREST_TRANSITIVE",
    0x00000010: "CROSS_ORGANIZATION",
    0x00000020: "WITHIN_FOREST",
    0x00000040: "TREAT_AS_EXTERNAL",
    0x00000080: "USES_RC4_ENCRYPTION",
    0x00000200: "CROSS_ORGANIZATION_NO_TGT_DELEGATION",
    0x00000800: "CROSS_ORGANIZATION_ENABLE_TGT_DELEGATION",
    0x00000400: "PIM_TRUST",
}

# trustDirection
# From: https://msdn.microsoft.com/en-us/library/cc223768.aspx
TRUST_DIRECTIONS = {
    0x00000000: "DISABLED",
    0x00000001: "INBOUND",
    0x00000002: "OUTBOUND",
    0x00000003: "BIDIRECTIONAL",
}

# trustType
# From: https://learn.microsoft.com/en-us/openspecs/windows_protocols/ms-adts/36565693-b5e4-4f37-b0a8-c1b12138e18e
TRUST_TYPE = {
    0x00000001: "DOWNLEVEL",
    0x00000002: "UPLEVEL",
    0x00000003: "MIT",
}

# BloodHound trust types
# ! Deprecated
BH_TRUST_TYPE = {
    "ParentChild": 0,
    "CrossLink": 1,
    "Forest": 2,
    "External": 3,
    "Unknown": 4,
}

# BloodHound 4.1 mapping
BH_41_TRUST_DIRECTION = {
    0: "Disabled",
    1: "Inbound",
    2: "Outbound",
    3: "Bidirectional",
}

# Common SIDs
WELLKNOWN_SIDS = {
    "S-1-0": ("Null Authority", "USER"),
    "S-1-0-0": ("Nobody", "USER"),
    "S-1-1": ("World Authority", "USER"),
    "S-1-1-0": ("Everyone", "GROUP"),
    "S-1-2": ("Local Authority", "USER"),
    "S-1-2-0": ("Local", "GROUP"),
    "S-1-2-1": ("Console Logon", "GROUP"),
    "S-1-3": ("Creator Authority", "USER"),
    "S-1-3-0": ("Creator Owner", "USER"),
    "S-1-3-1": ("Creator Group", "GROUP"),
    "S-1-3-2": ("Creator Owner Server", "COMPUTER"),
    "S-1-3-3": ("Creator Group Server", "COMPUTER"),
    "S-1-3-4": ("Owner Rights", "GROUP"),
    "S-1-4": ("Non-unique Authority", "USER"),
    "S-1-5": ("NT Authority", "USER"),
    "S-1-5-1": ("Dialup", "GROUP"),
    "S-1-5-2": ("Network", "GROUP"),
    "S-1-5-3": ("Batch", "GROUP"),
    "S-1-5-4": ("Interactive", "GROUP"),
    "S-1-5-6": ("Service", "GROUP"),
    "S-1-5-7": ("Anonymous", "GROUP"),
    "S-1-5-8": ("Proxy", "GROUP"),
    "S-1-5-9": ("Enterprise Domain Controllers", "GROUP"),
    "S-1-5-10": ("Principal Self", "USER"),
    "S-1-5-11": ("Authenticated Users", "GROUP"),
    "S-1-5-12": ("Restricted Code", "GROUP"),
    "S-1-5-13": ("Terminal Server Users", "GROUP"),
    "S-1-5-14": ("Remote Interactive Logon", "GROUP"),
    "S-1-5-15": ("This Organization", "GROUP"),
    "S-1-5-17": ("IUSR", "USER"),
    "S-1-5-18": ("Local System", "USER"),
    "S-1-5-19": ("NT Authority", "USER"),
    "S-1-5-20": ("Network Service", "USER"),
    "S-1-5-80-0": ("All Services ", "GROUP"),
    "S-1-5-32-544": ("Administrators", "GROUP"),
    "S-1-5-32-545": ("Users", "GROUP"),
    "S-1-5-32-546": ("Guests", "GROUP"),
    "S-1-5-32-547": ("Power Users", "GROUP"),
    "S-1-5-32-548": ("Account Operators", "GROUP"),
    "S-1-5-32-549": ("Server Operators", "GROUP"),
    "S-1-5-32-550": ("Print Operators", "GROUP"),
    "S-1-5-32-551": ("Backup Operators", "GROUP"),
    "S-1-5-32-552": ("Replicators", "GROUP"),
    "S-1-5-32-554": ("Pre-Windows 2000 Compatible Access", "GROUP"),
    "S-1-5-32-555": ("Remote Desktop Users", "GROUP"),
    "S-1-5-32-556": ("Network Configuration Operators", "GROUP"),
    "S-1-5-32-557": ("Incoming Forest Trust Builders", "GROUP"),
    "S-1-5-32-558": ("Performance Monitor Users", "GROUP"),
    "S-1-5-32-559": ("Performance Log Users", "GROUP"),
    "S-1-5-32-560": ("Windows Authorization Access Group", "GROUP"),
    "S-1-5-32-561": ("Terminal Server License Servers", "GROUP"),
    "S-1-5-32-562": ("Distributed COM Users", "GROUP"),
    "S-1-5-32-568": ("IIS_IUSRS", "GROUP"),
    "S-1-5-32-569": ("Cryptographic Operators", "GROUP"),
    "S-1-5-32-573": ("Event Log Readers", "GROUP"),
    "S-1-5-32-574": ("Certificate Service DCOM Access", "GROUP"),
    "S-1-5-32-575": ("RDS Remote Access Servers", "GROUP"),
    "S-1-5-32-576": ("RDS Endpoint Servers", "GROUP"),
    "S-1-5-32-577": ("RDS Management Servers", "GROUP"),
    "S-1-5-32-578": ("Hyper-V Administrators", "GROUP"),
    "S-1-5-32-579": ("Access Control Assistance Operators", "GROUP"),
    "S-1-5-32-580": ("Access Control Assistance Operators", "GROUP"),
    "S-1-5-32-582": ("Storage Replica Administrators", "GROUP"),
}

# AD forest/domain functional levels
# TODO: Documentation
FUNCTIONAL_LEVELS = {
    0: "2000 Mixed/Native",
    1: "2003 Interim",
    2: "2003",
    3: "2008",
    4: "2008 R2",
    5: "2012",
    6: "2012 R2",
    7: "2016",
}

# Common attribute translations
# More for reference than anything
ATTR_TRANSLATIONS = {
    "sAMAccountName": "SAM Name",
    "cn": "CN",
    "operatingSystem": "Operating System",
    "operatingSystemServicePack": "Service Pack",
    "operatingSystemVersion": "OS Version",
    "userAccountControl": "Flags",
    "objectSid": "SID",
    "memberOf": "Member of groups",
    "primaryGroupId": "Primary group",
    "dNSHostName": "DNS Hostname",
    "whenCreated": "Created on",
    "whenChanged": "Changed on",
    "IPv4": "IPv4 Address",
    "lockOutObservationWindow": "Lockout time window",
    "lockoutDuration": "Lockout Duration",
    "lockoutThreshold": "Lockout Threshold",
    "maxPwdAge": "Max password age",
    "minPwdAge": "Min password age",
    "minPwdLength": "Min password length",
    "pwdHistoryLength": "Password history length",
    "pwdProperties": "Password properties",
    "ms-DS-MachineAccountQuota": "Machine Account Quota",
    "flatName": "NETBIOS Domain name",
}

# Types by char + potential usage:
# ATTb (type: signed 32-bit int -> object)
# ATTj (type: signed 32-bit int)
# ATTl and ATTq (type: currency) look related to datetime
# ATTm (type: large text)
# ATTp (type: large binary data)
# ATTr (type: large binary data)
ESENT_TO_LDAP = {
    "ATTb131079": "subRefs",
    "ATTb131088": "nCName",
    "ATTb131108": "dMDLocation",
    "ATTb1376270": "documentAuthor",
    "ATTb1376277": "secretary",
    "ATTb1376294": "associatedName",
    "ATTb33": "roleOccupant",
    "ATTb34": "seeAlso",
    "ATTb49": "distinguishedName",
    "ATTb50": "uniqueMember",
    "ATTb589856": "domainPolicyObject",
    "ATTb589864": "fromServer",
    "ATTb589881": "defaultLocalPolicyObject",
    "ATTb589921": "preferredOU",
    "ATTb590037": "defaultClassStore",
    "ATTb590038": "nextLevelStore",
    "ATTb590127": "notificationList",
    "ATTb590192": "rIDManagerReference",
    "ATTb590193": "fSMORoleOwner",
    "ATTb590246": "domainPolicyReference",
    "ATTb590281": "localPolicyReference",
    "ATTb590295": "trustParent",
    "ATTb590296": "domainCrossRef",
    "ATTb590304": "defaultGroup",
    "ATTb590318": "siteServer",
    "ATTb590338": "physicalLocationObject",
    "ATTb590341": "ipsecPolicyReference",
    "ATTb590361": "dynamicLDAPServer",
    "ATTb590381": "parentCA",
    "ATTb590448": "ipsecOwnersReference",
    "ATTb590450": "ipsecISAKMPReference",
    "ATTb590451": "ipsecNFAReference",
    "ATTb590452": "ipsecNegotiationPolicyReference",
    "ATTb590453": "ipsecFilterReference",
    "ATTb590468": "showInAddressBook",
    "ATTb590476": "assistant",
    "ATTb590488": "syncWithObject",
    "ATTb590492": "domainCAs",
    "ATTb590493": "rIDSetReferences",
    "ATTb590498": "rootTrust",
    "ATTb590508": "certificateAuthorityObject",
    "ATTb590510": "domainID",
    "ATTb590513": "cRLObject",
    "ATTb590518": "previousParentCA",
    "ATTb590519": "pendingParentCA",
    "ATTb590520": "currentParentCA",
    "ATTb590605": "lastKnownParent",
    "ATTb590606": "objectCategory",
    "ATTb590607": "defaultObjectCategory",
    "ATTb590615": "transportType",
    "ATTb590680": "netbootNewMachineOU",
    "ATTb590752": "mSMQOutRoutingServers",
    "ATTb590753": "mSMQInRoutingServers",
    "ATTb590767": "mSMQSite1",
    "ATTb590768": "mSMQSite2",
    "ATTb590769": "mSMQSiteGates",
    "ATTb591049": "mSMQPrevSiteGates",
    "ATTb591066": "dNReferenceUpdate",
    "ATTb591068": "addressBookRoots",
    "ATTb591069": "globalAddressList",
    "ATTb591070": "interSiteTopologyGenerator",
    "ATTb591134": "mSMQSiteGatesMig",
    "ATTb591170": "templateRoots",
    "ATTb591251": "msCOM-DefaultPartitionLink",
    "ATTb591268": "msDS-Preferred-GC-Site",
    "ATTb591923": "msDS-ClaimAttributeSource",
    "ATTb592001": "msKds-DomainID",
    "ATTb592085": "msDS-DeviceLocation",
    "ATTc0": "objectClass",
    "ATTc131080": "possSuperiors",
    "ATTc131093": "subClassOf",
    "ATTc131094": "governsID",
    "ATTc131096": "mustContain",
    "ATTc131097": "mayContain",
    "ATTc131098": "rDNAttID",
    "ATTc131102": "ATTributeID",
    "ATTc131104": "ATTributeSyntax",
    "ATTc131423": "auxiliaryClass",
    "ATTc590019": "systemPossSuperiors",
    "ATTc590020": "systemMayContain",
    "ATTc590021": "systemMustContain",
    "ATTc590022": "systemAuxiliaryClass",
    "ATTc590719": "transportAddressAttribute",
    "ATTe131422": "addressType",
    "ATTe131531": "networkAddress",
    "ATTe2": "knowledgeInformation",
    "ATTe590479": "legacyExchangeDN",
    "ATTe590746": "mSMQLabel",
    "ATTe590757": "mSMQComputerType",
    "ATTe590764": "mSMQCSPName",
    "ATTe590789": "mSMQSiteName",
    "ATTf131425": "displayNamePrintable",
    "ATTf1376293": "associatedDomain",
    "ATTf1966082": "unstructuredName",
    "ATTf2162997": "msSFU30Name",
    "ATTf2163011": "msSFU30Aliases",
    "ATTf2163012": "msSFU30KeyValues",
    "ATTf2163027": "msSFU30NisDomain",
    "ATTf2163028": "msSFU30Domains",
    "ATTf2163029": "msSFU30YpServers",
    "ATTf2163033": "msSFU30NSMAPFieldPosition",
    "ATTf2163036": "msSFU30NetgroupHostAtDomain",
    "ATTf2163037": "msSFU30NetgroupUserAtDomain",
    "ATTf2163040": "msSFU30CryptMethod",
    "ATTf2424834": "gecos",
    "ATTf2424835": "unixHomeDirectory",
    "ATTf2424836": "loginShell",
    "ATTf2424844": "memberUid",
    "ATTf2424845": "memberNisNetgroup",
    "ATTf2424846": "nisNetgroupTriple",
    "ATTf2424848": "ipServiceProtocol",
    "ATTf2424851": "ipHostNumber",
    "ATTf2424852": "ipNetworkNumber",
    "ATTf2424853": "ipNetmaskNumber",
    "ATTf2424854": "macAddress",
    "ATTf2424855": "bootParameter",
    "ATTf2424856": "bootFile",
    "ATTf2424858": "nisMapName",
    "ATTf2424859": "nisMapEntry",
    "ATTf27": "destinationIndicator",
    "ATTf5": "serialNumber",
    "ATTf590528": "dhcpServers",
    "ATTf590529": "dhcpSubnets",
    "ATTf590530": "dhcpMask",
    "ATTf590531": "dhcpRanges",
    "ATTf590532": "dhcpSites",
    "ATTf590533": "dhcpReservations",
    "ATTf590534": "superScopes",
    "ATTf590537": "optionsLocation",
    "ATTf590540": "mscopeId",
    "ATTf590541": "dhcpState",
    "ATTf590947": "msNPCalledStationID",
    "ATTf590948": "msNPCallingStationID",
    "ATTf590954": "msNPSavedCallingStationID",
    "ATTf590969": "msRADIUSCallbackNumber",
    "ATTf590982": "msRADIUSFramedRoute",
    "ATTf591013": "msRASSavedCallbackNumber",
    "ATTf591015": "msRASSavedFramedRoute",
    "ATTf591737": "msRADIUS-FramedInterfaceId",
    "ATTf591738": "msRADIUS-SavedFramedInterfaceId",
    "ATTf591739": "msRADIUS-FramedIpv6Prefix",
    "ATTf591740": "msRADIUS-SavedFramedIpv6Prefix",
    "ATTf591741": "msRADIUS-FramedIpv6Route",
    "ATTf591742": "msRADIUS-SavedFramedIpv6Route",
    "ATTg24": "x121Address",
    "ATTg25": "internationalISDNNumber",
    "ATTh590442": "wellKnownObjects",
    "ATTh591073": "proxiedObjectName",
    "ATTh591183": "otherWellKnownObjects",
    "ATTh591232": "mS-DS-ReplicatesNCReason",
    "ATTi131105": "isSingleValued",
    "ATTi131120": "isDeleted",
    "ATTi131241": "showInAdvancedViewOnly",
    "ATTi131452": "extendedCharsAllowed",
    "ATTi131595": "proxyGenerationEnabled",
    "ATTi131629": "Enabled",
    "ATTi2293769": "msDFSR-Enabled",
    "ATTi2293779": "msDFSR-RdcEnabled",
    "ATTi2293788": "msDFSR-ReadOnly",
    "ATTi2293792": "msDFSR-DisablePacketPrivacy",
    "ATTi589848": "contentIndexingAllowed",
    "ATTi589860": "enabledConnection",
    "ATTi589865": "generatedConnection",
    "ATTi589994": "systemOnly",
    "ATTi590066": "printCollate",
    "ATTi590067": "printColor",
    "ATTi590099": "printKeepPrintedJobs",
    "ATTi590105": "printStaplingSupported",
    "ATTi590202": "dnsAllowDynamic",
    "ATTi590203": "dnsAllowXFR",
    "ATTi590342": "defaultHidingValue",
    "ATTi590463": "isMemberOfPartialAttributeSet",
    "ATTi590485": "isDefunct",
    "ATTi590592": "aCSEnableRSVPMessageLogging",
    "ATTi590594": "aCSEnableACSService",
    "ATTi590630": "treatAsLeaf",
    "ATTi590673": "netbootAllowNewClients",
    "ATTi590674": "netbootLimitClients",
    "ATTi590677": "netbootAnswerRequests",
    "ATTi590678": "netbootAnswerOnlyValidClients",
    "ATTi590692": "isCriticalSystemObject",
    "ATTi590723": "aCSEnableRSVPAccounting",
    "ATTi590742": "mSMQJournal",
    "ATTi590747": "mSMQAuthenticate",
    "ATTi590750": "mSMQTransactional",
    "ATTi590758": "mSMQForeign",
    "ATTi590763": "mSMQNameStyle",
    "ATTi590776": "mSMQMigrated",
    "ATTi590785": "mSMQSiteForeign",
    "ATTi590943": "msNPAllowDialin",
    "ATTi591036": "isEphemeral",
    "ATTi591050": "mSMQDependentClientServices",
    "ATTi591051": "mSMQRoutingServices",
    "ATTi591052": "mSMQDsServices",
    "ATTi591061": "mSMQRoutingService",
    "ATTi591062": "mSMQDsService",
    "ATTi591063": "mSMQDependentClientService",
    "ATTi591135": "printDuplexSupported",
    "ATTi591197": "mS-SQL-Clustered",
    "ATTi591216": "mS-SQL-InformationDirectory",
    "ATTi591218": "mS-SQL-AllowAnonymousSubscription",
    "ATTi591227": "mS-SQL-AllowKnownPullSubscription",
    "ATTi591228": "mS-SQL-AllowImmediateUpdatingSubscription",
    "ATTi591229": "mS-SQL-AllowQueuedUpdatingSubscription",
    "ATTi591230": "mS-SQL-AllowSnapshotFilesFTPDownloading",
    "ATTi591231": "mS-SQL-ThirdParty",
    "ATTi591238": "dNSTombstoned",
    "ATTi591537": "MSMQ-SecuredSource",
    "ATTi591604": "hideFromAB",
    "ATTi591629": "msDS-AzGenerateAudits",
    "ATTi591642": "msDS-AzTaskIsRoleDefinition",
    "ATTi591803": "msTSAllowLogon",
    "ATTi591808": "msTSReconnectionAction",
    "ATTi591809": "msTSBrokenConnectionAction",
    "ATTi591810": "msTSConnectClientDrives",
    "ATTi591811": "msTSConnectPrinterDrives",
    "ATTi591812": "msTSDefaultToMainPrinter",
    "ATTi591839": "msDS-PasswordComplexityEnabled",
    "ATTi591840": "msDS-PasswordReversibleEncryptionEnabled",
    "ATTi591882": "isRecycled",
    "ATTi591919": "msDS-IsUsedAsResourceSecurityAttribute",
    "ATTi591954": "msDNS-IsSigned",
    "ATTi591955": "msDNS-SignWithNSEC3",
    "ATTi591956": "msDNS-NSEC3OptOut",
    "ATTi591959": "msDNS-RFC5011KeyRollovers",
    "ATTi591970": "msDNS-ParentHasSecureDelegation",
    "ATTi591983": "msDS-ClaimIsValueSpaceRestricted",
    "ATTi591984": "msDS-ClaimIsSingleValued",
    "ATTi592010": "msDS-IsPossibleValuesPresent",
    "ATTi592037": "msDS-RIDPoolAllocationEnabled",
    "ATTi592072": "msDS-IsEnabled",
    "ATTi592094": "msDS-IsManaged",
    "ATTi592095": "msDS-CloudIsManaged",
    "ATTi592099": "msDS-CloudIsEnabled",
    "ATTi592121": "msDS-AuthNPolicyEnforced",
    "ATTi592122": "msDS-AuthNPolicySiloEnforced",
    "ATTi592138": "msDS-IsCompliant",
    "ATTi592168": "msDS-ExpirePasswordsOnSmartCardOnlyAccounts",
    "ATTi592172": "msDS-UserAllowedNTLMNetworkAuthentication",
    "ATTi592173": "msDS-ServiceAllowedNTLMNetworkAuthentication",
    "ATTj131073": "instanceType",
    "ATTj131106": "rangeLower",
    "ATTj131107": "rangeUpper",
    "ATTj131121": "mAPIID",
    "ATTj131122": "linkID",
    "ATTj131126": "tombstoneLifetime",
    "ATTj131148": "objectVersion",
    "ATTj131207": "cost",
    "ATTj131303": "oMSyntax",
    "ATTj131373": "garbageCollPeriod",
    "ATTj131406": "searchFlags",
    "ATTj131442": "objectClassCategory",
    "ATTj131541": "USNIntersite",
    "ATTj131543": "schemaVersion",
    "ATTj2163030": "msSFU30MaxGidNumber",
    "ATTj2163031": "msSFU30MaxUidNumber",
    "ATTj2163038": "msSFU30IsValidContainer",
    "ATTj2293770": "msDFSR-ReplicationGroupType",
    "ATTj2293771": "msDFSR-TombstoneExpiryInMin",
    "ATTj2293776": "msDFSR-Flags",
    "ATTj2293777": "msDFSR-Options",
    "ATTj2293782": "msDFSR-RootFence",
    "ATTj2293785": "msDFSR-Priority",
    "ATTj2293789": "msDFSR-CachePolicy",
    "ATTj2293790": "msDFSR-MinDurationCacheInMin",
    "ATTj2293791": "msDFSR-MaxAgeInCacheInMin",
    "ATTj2293797": "msDFSR-Options2",
    "ATTj2293800": "msDFSR-StagingCleanupTriggerInPercent",
    "ATTj2424832": "uidNumber",
    "ATTj2424833": "gidNumber",
    "ATTj2424837": "shadowLastChange",
    "ATTj2424838": "shadowMin",
    "ATTj2424839": "shadowMax",
    "ATTj2424840": "shadowWarning",
    "ATTj2424841": "shadowInactive",
    "ATTj2424842": "shadowExpire",
    "ATTj2424843": "shadowFlag",
    "ATTj2424847": "ipServicePort",
    "ATTj2424849": "ipProtocolNumber",
    "ATTj2424850": "oncRpcNumber",
    "ATTj28": "preferredDeliveryMethod",
    "ATTj589832": "userAccountControl",
    "ATTj589835": "authenticationOptions",
    "ATTj589836": "badPwdCount",
    "ATTj589840": "codePage",
    "ATTj589849": "countryCode",
    "ATTj589855": "fRSReplicaSetType",
    "ATTj589862": "flags",
    "ATTj589880": "localPolicyFlags",
    "ATTj589882": "localeID",
    "ATTj589892": "machineArchitecture",
    "ATTj589895": "machineRole",
    "ATTj589897": "lockoutThreshold",
    "ATTj589903": "minPwdLength",
    "ATTj589912": "nextRid",
    "ATTj589917": "pwdProperties",
    "ATTj589919": "pwdHistoryLength",
    "ATTj589922": "primaryGroupID",
    "ATTj589932": "remoteSourceType",
    "ATTj589941": "rpcNsPriority",
    "ATTj589944": "schemaFlagsEx",
    "ATTj589956": "trustDirection",
    "ATTj589958": "trustPosixOffset",
    "ATTj589960": "trustType",
    "ATTj589965": "versionNumber",
    "ATTj589968": "operatorCount",
    "ATTj589969": "revision",
    "ATTj589974": "adminCount",
    "ATTj589976": "groupAttributes",
    "ATTj589977": "rid",
    "ATTj589978": "serverState",
    "ATTj589979": "uASCompat",
    "ATTj589981": "serverRole",
    "ATTj589993": "logonCount",
    "ATTj590055": "priority",
    "ATTj590056": "defaultPriority",
    "ATTj590057": "printStartTime",
    "ATTj590058": "printEndTime",
    "ATTj590062": "printMaxResolutionSupported",
    "ATTj590065": "printMaxCopies",
    "ATTj590071": "printAttributes",
    "ATTj590100": "driverVersion",
    "ATTj590101": "printMaxXExtent",
    "ATTj590102": "printMaxYExtent",
    "ATTj590103": "printMinXExtent",
    "ATTj590104": "printMinYExtent",
    "ATTj590106": "printMemory",
    "ATTj590108": "bytesPerMinute",
    "ATTj590109": "printRate",
    "ATTj590114": "printNumberUp",
    "ATTj590126": "sAMAccountType",
    "ATTj590131": "options",
    "ATTj590148": "packageType",
    "ATTj590151": "packageFlags",
    "ATTj590152": "versionNumberHi",
    "ATTj590153": "versionNumberLo",
    "ATTj590181": "nTMixedDomain",
    "ATTj590198": "rIDNextRID",
    "ATTj590199": "systemFlags",
    "ATTj590204": "dnsSecureSecondaries",
    "ATTj590205": "dnsNotifySecondaries",
    "ATTj590282": "qualityOfService",
    "ATTj590294": "trustAttributes",
    "ATTj590309": "fRSUpdateTimeout",
    "ATTj590314": "fRSDSPoll",
    "ATTj590328": "seqNotification",
    "ATTj590330": "objectCount",
    "ATTj590331": "volumeCount",
    "ATTj590358": "fRSLevelLimit",
    "ATTj590400": "meetingMaxParticipants",
    "ATTj590413": "meetingBandwidth",
    "ATTj590446": "ipsecDataType",
    "ATTj590455": "printPagesPerMinute",
    "ATTj590457": "policyReplicationFlags",
    "ATTj590460": "privilegeAttributes",
    "ATTj590490": "syncAttributes",
    "ATTj590501": "replTopologyStayOfExecution",
    "ATTj590523": "dhcpType",
    "ATTj590574": "groupType",
    "ATTj590577": "nameServiceFlags",
    "ATTj590578": "rpcNsEntryFlags",
    "ATTj590579": "domainIdentifier",
    "ATTj590581": "aCSDirection",
    "ATTj590585": "aCSMaxDurationPerFlow",
    "ATTj590586": "aCSServiceType",
    "ATTj590587": "aCSTotalNoOfFlows",
    "ATTj590588": "aCSPriority",
    "ATTj590593": "aCSEventLogLevel",
    "ATTj590598": "aCSMaxNoOfLogFiles",
    "ATTj590599": "aCSMaxSizeOfRSVPLogFile",
    "ATTj590600": "aCSDSBMPriority",
    "ATTj590601": "aCSDSBMRefresh",
    "ATTj590602": "aCSDSBMDeadTime",
    "ATTj590603": "aCSCacheTimeout",
    "ATTj590670": "msiScriptSize",
    "ATTj590671": "installUiLevel",
    "ATTj590672": "appSchemaVersion",
    "ATTj590675": "netbootMaxClients",
    "ATTj590676": "netbootCurrentClientCount",
    "ATTj590698": "fRSFlags",
    "ATTj590701": "fRSPartnerAuthLevel",
    "ATTj590716": "gPOptions",
    "ATTj590717": "gPCFunctionalityVersion",
    "ATTj590725": "aCSMaxNoOfAccountFiles",
    "ATTj590726": "aCSMaxSizeOfRSVPAccountFile",
    "ATTj590743": "mSMQQuota",
    "ATTj590744": "mSMQBasePriority",
    "ATTj590745": "mSMQJournalQuota",
    "ATTj590748": "mSMQPrivacyLevel",
    "ATTj590754": "mSMQServiceType",
    "ATTj590759": "mSMQOSType",
    "ATTj590765": "mSMQLongLived",
    "ATTj590766": "mSMQVersion",
    "ATTj590770": "mSMQCost",
    "ATTj590774": "mSMQServices",
    "ATTj590784": "mSMQNt4Stub",
    "ATTj590786": "mSMQQueueQuota",
    "ATTj590787": "mSMQQueueJournalQuota",
    "ATTj590788": "mSMQNt4Flags",
    "ATTj590977": "msRADIUSFramedIPAddress",
    "ATTj590995": "msRADIUSServiceType",
    "ATTj591014": "msRASSavedFramedIPAddress",
    "ATTj591071": "interSiteTopologyRenew",
    "ATTj591072": "interSiteTopologyFailover",
    "ATTj591132": "mSMQInterval1",
    "ATTj591133": "mSMQInterval2",
    "ATTj591151": "pKIDefaultKeySpec",
    "ATTj591153": "pKIMaxIssuingDepth",
    "ATTj591160": "replInterval",
    "ATTj591168": "dSUIAdminMaximum",
    "ATTj591169": "dSUIShellMaximum",
    "ATTj591177": "localizationDisplayId",
    "ATTj591178": "scopeFlags",
    "ATTj591180": "validAccesses",
    "ATTj591185": "mS-DS-ConsistencyChildCount",
    "ATTj591192": "mS-SQL-Build",
    "ATTj591194": "mS-SQL-CharacterSet",
    "ATTj591196": "mS-SQL-UnicodeSortOrder",
    "ATTj591235": "ms-DS-MachineAccountQuota",
    "ATTj591253": "msPKI-RA-Signature",
    "ATTj591254": "msPKI-Enrollment-Flag",
    "ATTj591255": "msPKI-Private-Key-Flag",
    "ATTj591256": "msPKI-Certificate-Name-Flag",
    "ATTj591257": "msPKI-Minimal-Key-Size",
    "ATTj591258": "msPKI-Template-Schema-Version",
    "ATTj591259": "msPKI-Template-Minor-Revision",
    "ATTj591283": "msDS-Behavior-Version",
    "ATTj591452": "msWMI-IntDefault",
    "ATTj591453": "msWMI-IntMax",
    "ATTj591454": "msWMI-IntMin",
    "ATTj591455": "msWMI-IntValidValues",
    "ATTj591487": "msDS-Replication-Notify-First-DSA-Delay",
    "ATTj591488": "msDS-Replication-Notify-Subsequent-DSA-Delay",
    "ATTj591495": "msPKI-OID-Attribute",
    "ATTj591501": "msWMI-Genus",
    "ATTj591502": "msWMI-intFlags1",
    "ATTj591503": "msWMI-intFlags2",
    "ATTj591504": "msWMI-intFlags3",
    "ATTj591505": "msWMI-intFlags4",
    "ATTj591540": "msDS-IntId",
    "ATTj591544": "msDS-ReplicationEpoch",
    "ATTj591608": "msDS-LogonTimeSyncInterval",
    "ATTj591612": "msDS-PerUserTrustQuota",
    "ATTj591613": "msDS-AllUsersTrustQuota",
    "ATTj591614": "msDS-PerUserTrustTombstonesQuota",
    "ATTj591619": "msDS-AzDomainTimeout",
    "ATTj591620": "msDS-AzScriptEngineCacheMax",
    "ATTj591621": "msDS-AzScriptTimeout",
    "ATTj591624": "msDS-AzOperationID",
    "ATTj591646": "msieee80211-DataType",
    "ATTj591648": "msDS-AzMajorVersion",
    "ATTj591649": "msDS-AzMinorVersion",
    "ATTj591659": "msDS-Integer",
    "ATTj591666": "msDs-MaxValues",
    "ATTj591669": "msDS-QuotaAmount",
    "ATTj591670": "msDS-DefaultQuota",
    "ATTj591671": "msDS-TombstoneQuotaFactor",
    "ATTj591753": "msDS-SecondaryKrbTgtNumber",
    "ATTj591787": "msDS-SupportedEncryptionTypes",
    "ATTj591796": "msDS-FailedInteractiveLogonCount",
    "ATTj591797": "msDS-FailedInteractiveLogonCountAtLastSuccessfulLogon",
    "ATTj591804": "msTSRemoteControl",
    "ATTj591805": "msTSMaxDisconnectionTime",
    "ATTj591806": "msTSMaxConnectionTime",
    "ATTj591807": "msTSMaxIdleTime",
    "ATTj591821": "msDS-HABSeniorityIndex",
    "ATTj591837": "msDS-MinimumPasswordLength",
    "ATTj591838": "msDS-PasswordHistoryLength",
    "ATTj591843": "msDS-LockoutThreshold",
    "ATTj591847": "msDS-PasswordSettingsPrecedence",
    "ATTj591848": "msDS-NcType",
    "ATTj591854": "msDFS-SchemaMajorVersion",
    "ATTj591855": "msDFS-SchemaMinorVersion",
    "ATTj591859": "msDFS-Ttlv2",
    "ATTj591887": "msDS-OptionalFeatureFlags",
    "ATTj591890": "msDS-RequiredDomainBehaviorVersion",
    "ATTj591892": "msDS-DeletedObjectLifetime",
    "ATTj591895": "msTSEndpointType",
    "ATTj591903": "msDS-RequiredForestBehaviorVersion",
    "ATTj591957": "msDNS-MaintainTrustAnchor",
    "ATTj591958": "msDNS-DSRecordAlgorithms",
    "ATTj591960": "msDNS-NSEC3HashAlgorithm",
    "ATTj591961": "msDNS-NSEC3RandomSaltLength",
    "ATTj591962": "msDNS-NSEC3Iterations",
    "ATTj591963": "msDNS-DNSKEYRecordSetTTL",
    "ATTj591964": "msDNS-DSRecordSetTTL",
    "ATTj591965": "msDNS-SignatureInceptionOffset",
    "ATTj591966": "msDNS-SecureDelegationPollingPeriod",
    "ATTj591971": "msDNS-PropagationTime",
    "ATTj591997": "msKds-PublicKeyLength",
    "ATTj591998": "msKds-PrivateKeyLength",
    "ATTj592000": "msKds-Version",
    "ATTj592023": "msDS-ManagedPasswordInterval",
    "ATTj592065": "msDS-RegistrationQuota",
    "ATTj592066": "msDS-MaximumRegistrationInactivityPeriod",
    "ATTj592081": "msDS-DeviceObjectVersion",
    "ATTj592149": "msDS-DeviceTrustType",
    "ATTj592174": "msDS-StrongNTLMPolicy",
    "ATTk131081": "helpData32",
    "ATTk1310860": "userSMIMECertificate",
    "ATTk131146": "dSASignature",
    "ATTk131155": "repsTo",
    "ATTk131163": "repsFrom",
    "ATTk131187": "invocationId",
    "ATTk131286": "originalDisplayTableMSDOS",
    "ATTk131290": "oMObjectClass",
    "ATTk131327": "addressSyntax",
    "ATTk131396": "addressEntryDisplayTable",
    "ATTk131397": "perMsgDialogDisplayTable",
    "ATTk131398": "perRecipDialogDisplayTable",
    "ATTk131472": "addressEntryDisplayTableMSDOS",
    "ATTk131474": "helpData16",
    "ATTk131517": "originalDisplayTable",
    "ATTk1376263": "photo",
    "ATTk1376311": "audio",
    "ATTk1376316": "jpegPhoto",
    "ATTk14": "searchGuide",
    "ATTk1441827": "thumbnailPhoto",
    "ATTk1441828": "thumbnailLogo",
    "ATTk1442008": "userPKCS12",
    "ATTk21": "telexNumber",
    "ATTk22": "teletexTerminalIdentifier",
    "ATTk2293762": "msDFSR-Extension",
    "ATTk2293774": "msDFSR-Schedule",
    "ATTk2293778": "msDFSR-ContentSetGuid",
    "ATTk2293783": "msDFSR-ReplicationGroupGuid",
    "ATTk26": "registeredAddress",
    "ATTk30": "supportedApplicationContext",
    "ATTk35": "userPassword",
    "ATTk36": "userCertificate",
    "ATTk37": "cACertificate",
    "ATTk38": "authorityRevocationList",
    "ATTk39": "certificateRevocationList",
    "ATTk40": "crossCertificatePair",
    "ATTk45": "x500uniqueIdentifier",
    "ATTk53": "deltaRevocationList",
    "ATTk58": "ATTributeCertificateAttribute",
    "ATTk589826": "objectGUID",
    "ATTk589827": "replPropertyMetaData",
    "ATTk589828": "replUpToDateVector",
    "ATTk589851": "currentValue",
    "ATTk589867": "fRSVersionGUID",
    "ATTk589879": "dBCSPwd",
    "ATTk589888": "logonHours",
    "ATTk589889": "logonWorkstation",
    "ATTk589896": "marshalledInterface",
    "ATTk589906": "moniker",
    "ATTk589913": "nTGroupMembers",
    "ATTk589914": "unicodePwd",
    "ATTk589918": "ntPwdHistory",
    "ATTk589924": "priorValue",
    "ATTk589925": "privateKey",
    "ATTk589946": "serviceClassID",
    "ATTk589947": "serviceClassInfo",
    "ATTk589949": "supplementalCredentials",
    "ATTk589953": "trustAuthIncoming",
    "ATTk589959": "trustAuthOutgoing",
    "ATTk589966": "winsockAddresses",
    "ATTk589972": "schemaIDGUID",
    "ATTk589973": "ATTributeSecurityGUID",
    "ATTk589984": "lmPwdHistory",
    "ATTk589990": "groupMembershipSAM",
    "ATTk590023": "serviceInstanceVersion",
    "ATTk590024": "controlAccessRights",
    "ATTk590026": "auditingPolicy",
    "ATTk590029": "pKTGuid",
    "ATTk590030": "pKT",
    "ATTk590035": "schedule",
    "ATTk590092": "eFSPolicy",
    "ATTk590093": "linkTrackSecret",
    "ATTk590144": "implementedCategories",
    "ATTk590145": "requiredCategories",
    "ATTk590146": "categoryId",
    "ATTk590156": "birthLocation",
    "ATTk590157": "oMTIndxGuid",
    "ATTk590158": "volTableIdxGUID",
    "ATTk590159": "currentLocation",
    "ATTk590160": "volTableGUID",
    "ATTk590161": "currMachineId",
    "ATTk590180": "foreignIdentifier",
    "ATTk590183": "netbootGUID",
    "ATTk590186": "siteGUID",
    "ATTk590206": "dnsRecord",
    "ATTk590244": "publicKeyPolicy",
    "ATTk590245": "domainWidePolicy",
    "ATTk590283": "machineWidePolicy",
    "ATTk590329": "oMTGuid",
    "ATTk590357": "fRSReplicaSetGUID",
    "ATTk590360": "fRSExtensions",
    "ATTk590362": "prefixMap",
    "ATTk590414": "meetingBlob",
    "ATTk590447": "ipsecData",
    "ATTk590464": "partialAttributeSet",
    "ATTk590469": "userCert",
    "ATTk590487": "partialAttributeDeletionList",
    "ATTk590497": "retiredReplDSASignatures",
    "ATTk590507": "cRLPartitionedRevocationList",
    "ATTk590509": "parentCACertificateChain",
    "ATTk590516": "previousCACertificates",
    "ATTk590517": "pendingCACertificates",
    "ATTk590538": "dhcpOptions",
    "ATTk590539": "dhcpClasses",
    "ATTk590542": "dhcpProperties",
    "ATTk590637": "upgradeProductCode",
    "ATTk590638": "msiScript",
    "ATTk590642": "productCode",
    "ATTk590668": "lDAPIPDenyList",
    "ATTk590689": "pekList",
    "ATTk590709": "terminalServer",
    "ATTk590741": "mSMQQueueType",
    "ATTk590749": "mSMQOwnerID",
    "ATTk590751": "mSMQSites",
    "ATTk590760": "mSMQEncryptKey",
    "ATTk590761": "mSMQSignKey",
    "ATTk590771": "mSMQSignCertificates",
    "ATTk590772": "mSMQDigests",
    "ATTk590775": "mSMQQMID",
    "ATTk590777": "mSMQSiteID",
    "ATTk590790": "mSMQDigestsMig",
    "ATTk590791": "mSMQSignCertificatesMig",
    "ATTk591037": "assocNTAccount",
    "ATTk591129": "moveTreeState",
    "ATTk591130": "dNSProperty",
    "ATTk591152": "pKIKeyUsage",
    "ATTk591155": "pKIExpirationPeriod",
    "ATTk591156": "pKIOverlapPeriod",
    "ATTk591161": "mSMQUserSid",
    "ATTk591182": "schemaInfo",
    "ATTk591184": "mS-DS-ConsistencyGuid",
    "ATTk591252": "msCOM-ObjectId",
    "ATTk591264": "msDs-Schema-Extensions",
    "ATTk591265": "msDS-Cached-Membership",
    "ATTk591267": "msDS-Site-Affinity",
    "ATTk591471": "msWMI-TargetObject",
    "ATTk591524": "msTAPI-ConferenceBlob",
    "ATTk591526": "msDS-TrustForestTrustInfo",
    "ATTk591607": "msDS-ExecuteScriptPassword",
    "ATTk591645": "msieee80211-Data",
    "ATTk591650": "msDS-RetiredReplNCSignatures",
    "ATTk591655": "msDS-ByteArray",
    "ATTk591667": "msDRM-IdentityCertificate",
    "ATTk591716": "msPKIRoamingTimeStamp",
    "ATTk591734": "unixUserPassword",
    "ATTk591773": "msDS-AzObjectGuid",
    "ATTk591777": "ms-net-ieee-80211-GP-PolicyReserved",
    "ATTk591780": "ms-net-ieee-8023-GP-PolicyReserved",
    "ATTk591789": "msFVE-RecoveryGuid",
    "ATTk591793": "samDomainUpdates",
    "ATTk591822": "msFVE-VolumeGuid",
    "ATTk591823": "msFVE-KeyPackage",
    "ATTk591856": "msDFS-GenerationGUIDv2",
    "ATTk591857": "msDFS-NamespaceIdentityGUIDv2",
    "ATTk591862": "msDFS-TargetListv2",
    "ATTk591865": "msDFS-LinkIdentityGUIDv2",
    "ATTk591877": "msImaging-PSPIdentifier",
    "ATTk591886": "msDS-OptionalFeatureGUID",
    "ATTk591905": "msSPP-CSVLKSkuId",
    "ATTk591906": "msSPP-KMSIds",
    "ATTk591909": "msSPP-OnlineLicense",
    "ATTk591910": "msSPP-PhoneLicense",
    "ATTk591911": "msSPP-ConfigLicense",
    "ATTk591912": "msSPP-IssuanceLicense",
    "ATTk591931": "msTPM-SrkPubThumbprint",
    "ATTk591967": "msDNS-SigningKeyDescriptors",
    "ATTk591968": "msDNS-SigningKeys",
    "ATTk591969": "msDNS-DNSKEYRecords",
    "ATTk591990": "msDS-GenerationId",
    "ATTk591994": "msKds-KDFParam",
    "ATTk591996": "msKds-SecretAgreementParam",
    "ATTk591999": "msKds-RootKeyData",
    "ATTk592004": "msImaging-ThumbprintHash",
    "ATTk592014": "msDS-TransformationRulesCompiled",
    "ATTk592021": "msDS-ManagedPasswordId",
    "ATTk592022": "msDS-ManagedPasswordPreviousId",
    "ATTk592058": "netbootDUID",
    "ATTk592064": "msDS-IssuerCertificates",
    "ATTk592076": "msDS-DeviceID",
    "ATTk592082": "msDS-RegisteredOwner",
    "ATTk592087": "msDS-RegisteredUsers",
    "ATTk592093": "msDS-IssuerPublicCertificates",
    "ATTk592097": "msDS-CloudAnchor",
    "ATTk592098": "msDS-CloudIssuerPublicCertificates",
    "ATTk592101": "msDS-UserAllowedToAuthenticateTo",
    "ATTk592102": "msDS-UserAllowedToAuthenticateFrom",
    "ATTk592104": "msDS-ComputerAllowedToAuthenticateTo",
    "ATTk592106": "msDS-ServiceAllowedToAuthenticateTo",
    "ATTk592107": "msDS-ServiceAllowedToAuthenticateFrom",
    "ATTk592139": "msDS-KeyId",
    "ATTk592140": "msDS-KeyMaterial",
    "ATTk592146": "msDS-CustomKeyInformation",
    "ATTl131074": "whenCreated",
    "ATTl131075": "whenChanged",
    "ATTl590305": "schemaUpdate",
    "ATTl590411": "meetingStartTime",
    "ATTl590412": "meetingEndTime",
    "ATTl590704": "fRSTimeLastCommand",
    "ATTl590705": "fRSTimeLastConfigChange",
    "ATTl591181": "dSCorePropagationData",
    "ATTl591446": "msDS-Entry-Time-To-Die",
    "ATTl591656": "msDS-DateTime",
    "ATTl591817": "msTSExpireDate",
    "ATTl591824": "msTSExpireDate2",
    "ATTl591827": "msTSExpireDate3",
    "ATTl591830": "msTSExpireDate4",
    "ATTl591858": "msDFS-LastModifiedv2",
    "ATTm10": "o",
    "ATTm11": "ou",
    "ATTm12": "title",
    "ATTm13": "description",
    "ATTm131085": "displayName",
    "ATTm131090": "otherTelephone",
    "ATTm131153": "info",
    "ATTm131190": "otherPager",
    "ATTm131203": "co",
    "ATTm131213": "department",
    "ATTm131218": "company",
    "ATTm131266": "adminDisplayName",
    "ATTm131282": "proxyAddresses",
    "ATTm131284": "dSHeuristics",
    "ATTm131298": "adminDescription",
    "ATTm131299": "extensionName",
    "ATTm131328": "streetAddress",
    "ATTm131349": "otherHomePhone",
    "ATTm131399": "helpFileName",
    "ATTm131516": "msExchAssistantName",
    "ATTm131532": "lDAPDisplayName",
    "ATTm131536": "wWWHomePage",
    "ATTm131665": "msExchLabeledURI",
    "ATTm131668": "msExchHouseIdentifier",
    "ATTm131670": "dmdName",
    "ATTm131682": "employeeNumber",
    "ATTm131685": "employeeType",
    "ATTm131687": "personalTitle",
    "ATTm131689": "homePostalAddress",
    "ATTm1376257": "uid",
    "ATTm1376258": "textEncodedORAddress",
    "ATTm1376259": "mail",
    "ATTm1376261": "drink",
    "ATTm1376262": "roomNumber",
    "ATTm1376264": "userClass",
    "ATTm1376265": "host",
    "ATTm1376267": "documentIdentifier",
    "ATTm1376268": "documentTitle",
    "ATTm1376269": "documentVersion",
    "ATTm1376271": "documentLocation",
    "ATTm1376276": "homePhone",
    "ATTm1376281": "dc",
    "ATTm1376297": "mobile",
    "ATTm1376298": "pager",
    "ATTm1376300": "uniqueIdentifier",
    "ATTm1376301": "organizationalStatus",
    "ATTm1376304": "buildingName",
    "ATTm1376312": "documentPublisher",
    "ATTm1441793": "carLicense",
    "ATTm1441794": "departmentNumber",
    "ATTm1441826": "middleName",
    "ATTm1441831": "preferredLanguage",
    "ATTm15": "businessCategory",
    "ATTm16": "postalAddress",
    "ATTm17": "postalCode",
    "ATTm18": "postOfficeBox",
    "ATTm19": "physicalDeliveryOfficeName",
    "ATTm1900601": "labeledURI",
    "ATTm1966088": "unstructuredAddress",
    "ATTm20": "telephoneNumber",
    "ATTm2162988": "msSFU30SearchContainer",
    "ATTm2162989": "msSFU30KeyAttributes",
    "ATTm2162990": "msSFU30FieldSeparator",
    "ATTm2162991": "msSFU30IntraFieldSeparator",
    "ATTm2162992": "msSFU30SearchAttributes",
    "ATTm2162993": "msSFU30ResultAttributes",
    "ATTm2162994": "msSFU30MapFilter",
    "ATTm2162995": "msSFU30MasterServerName",
    "ATTm2162996": "msSFU30OrderNumber",
    "ATTm2293761": "msDFSR-Version",
    "ATTm2293763": "msDFSR-RootPath",
    "ATTm2293765": "msDFSR-StagingPath",
    "ATTm2293767": "msDFSR-ConflictPath",
    "ATTm2293772": "msDFSR-FileFilter",
    "ATTm2293773": "msDFSR-DirectoryFilter",
    "ATTm2293775": "msDFSR-Keywords",
    "ATTm2293781": "msDFSR-DfsPath",
    "ATTm2293784": "msDFSR-DfsLinkTarget",
    "ATTm2293786": "msDFSR-DeletedPath",
    "ATTm2293794": "msDFSR-DefaultCompressionExclusionFilter",
    "ATTm2293795": "msDFSR-OnDemandExclusionFileFilter",
    "ATTm2293796": "msDFSR-OnDemandExclusionDirectoryFilter",
    "ATTm2293798": "msDFSR-CommonStagingPath",
    "ATTm23": "facsimileTelephoneNumber",
    "ATTm3": "cn",
    "ATTm4": "sn",
    "ATTm42": "givenName",
    "ATTm43": "initials",
    "ATTm44": "generationQualifier",
    "ATTm51": "houseIdentifier",
    "ATTm589825": "name",
    "ATTm589839": "msiScriptPath",
    "ATTm589843": "cOMClassID",
    "ATTm589844": "cOMInterfaceID",
    "ATTm589845": "cOMProgID",
    "ATTm589852": "dnsRoot",
    "ATTm589859": "employeeID",
    "ATTm589868": "homeDirectory",
    "ATTm589869": "homeDrive",
    "ATTm589872": "keywords",
    "ATTm589886": "scriptPath",
    "ATTm589907": "monikerDisplayName",
    "ATTm589910": "userWorkstations",
    "ATTm589911": "nETBIOSName",
    "ATTm589915": "otherLoginWorkstations",
    "ATTm589929": "remoteServerName",
    "ATTm589931": "remoteSource",
    "ATTm589933": "replicaSource",
    "ATTm589937": "rpcNsBindings",
    "ATTm589938": "rpcNsGroup",
    "ATTm589939": "rpcNsInterfaceID",
    "ATTm589942": "rpcNsProfileEntry",
    "ATTm589957": "trustPartner",
    "ATTm589961": "uNCName",
    "ATTm589962": "userParameters",
    "ATTm589963": "profilePath",
    "ATTm589975": "oEMInformation",
    "ATTm589980": "comment",
    "ATTm589982": "domainReplica",
    "ATTm590042": "applicationName",
    "ATTm590043": "iconPath",
    "ATTm590045": "sAMAccountName",
    "ATTm590046": "location",
    "ATTm590047": "serverName",
    "ATTm590048": "defaultSecurityDescriptor",
    "ATTm590052": "portName",
    "ATTm590053": "driverName",
    "ATTm590054": "printSeparatorFile",
    "ATTm590059": "printFormName",
    "ATTm590061": "printBinNames",
    "ATTm590064": "printOrientationsSupported",
    "ATTm590070": "printLanguage",
    "ATTm590073": "cOMCLSID",
    "ATTm590074": "cOMUniqueLIBID",
    "ATTm590075": "cOMTreatAsClassId",
    "ATTm590077": "cOMOtherProgId",
    "ATTm590078": "cOMTypelibId",
    "ATTm590079": "vendor",
    "ATTm590085": "division",
    "ATTm590089": "notes",
    "ATTm590094": "printShareName",
    "ATTm590095": "printOwner",
    "ATTm590096": "printNotify",
    "ATTm590097": "printStatus",
    "ATTm590098": "printSpooling",
    "ATTm590107": "assetNumber",
    "ATTm590110": "printRateUnit",
    "ATTm590111": "printNetworkAddress",
    "ATTm590112": "printMACAddress",
    "ATTm590113": "printMediaReady",
    "ATTm590123": "printMediaSupported",
    "ATTm590124": "printerName",
    "ATTm590125": "wbemPath",
    "ATTm590136": "rpcNsObjectID",
    "ATTm590138": "rpcNsTransferSyntax",
    "ATTm590149": "setupCommand",
    "ATTm590150": "packageName",
    "ATTm590154": "lastUpdateSequence",
    "ATTm590164": "rightsGuid",
    "ATTm590165": "appliesTo",
    "ATTm590168": "groupsToIgnore",
    "ATTm590169": "groupPriority",
    "ATTm590170": "desktopProfile",
    "ATTm590182": "netbootInitialization",
    "ATTm590185": "netbootMachineFilePath",
    "ATTm590187": "operatingSystem",
    "ATTm590188": "operatingSystemVersion",
    "ATTm590189": "operatingSystemServicePack",
    "ATTm590190": "rpcNsAnnotation",
    "ATTm590191": "rpcNsCodeset",
    "ATTm590239": "operatingSystemHotfix",
    "ATTm590307": "fRSFileFilter",
    "ATTm590308": "fRSDirectoryFilter",
    "ATTm590310": "fRSWorkingPath",
    "ATTm590311": "fRSRootPath",
    "ATTm590312": "fRSStagingPath",
    "ATTm590315": "fRSFaultCondition",
    "ATTm590322": "creationWizard",
    "ATTm590323": "contextMenu",
    "ATTm590324": "fRSServiceCommand",
    "ATTm590333": "serviceClassName",
    "ATTm590334": "serviceBindingInformation",
    "ATTm590335": "flatName",
    "ATTm590356": "superiorDNSRoot",
    "ATTm590363": "initialAuthIncoming",
    "ATTm590364": "initialAuthOutgoing",
    "ATTm590386": "adminPropertyPages",
    "ATTm590387": "shellPropertyPages",
    "ATTm590389": "meetingID",
    "ATTm590390": "meetingName",
    "ATTm590391": "meetingDescription",
    "ATTm590392": "meetingKeyword",
    "ATTm590393": "meetingLocation",
    "ATTm590394": "meetingProtocol",
    "ATTm590395": "meetingType",
    "ATTm590397": "meetingApplication",
    "ATTm590398": "meetingLanguage",
    "ATTm590401": "meetingOriginator",
    "ATTm590402": "meetingContactInfo",
    "ATTm590403": "meetingOwner",
    "ATTm590404": "meetingIP",
    "ATTm590405": "meetingScope",
    "ATTm590406": "meetingAdvertiseScope",
    "ATTm590407": "meetingURL",
    "ATTm590408": "meetingRating",
    "ATTm590409": "meetingIsEncrypted",
    "ATTm590410": "meetingRecurrence",
    "ATTm590434": "classDisplayName",
    "ATTm590438": "adminContextMenu",
    "ATTm590439": "shellContextMenu",
    "ATTm590443": "dNSHostName",
    "ATTm590444": "ipsecName",
    "ATTm590445": "ipsecID",
    "ATTm590458": "privilegeDisplayName",
    "ATTm590470": "otherFacsimileTelephoneNumber",
    "ATTm590471": "otherMobile",
    "ATTm590472": "primaryTelexNumber",
    "ATTm590473": "primaryInternationalISDNNumber",
    "ATTm590474": "mhsORAddress",
    "ATTm590475": "otherMailbox",
    "ATTm590480": "userPrincipalName",
    "ATTm590481": "serviceDNSName",
    "ATTm590483": "serviceDNSNameType",
    "ATTm590484": "treeName",
    "ATTm590495": "msiFileList",
    "ATTm590496": "categories",
    "ATTm590499": "catalogs",
    "ATTm590503": "creator",
    "ATTm590504": "queryPoint",
    "ATTm590505": "indexedScopes",
    "ATTm590506": "friendlyNames",
    "ATTm590511": "cAConnect",
    "ATTm590512": "cAWEBURL",
    "ATTm590514": "cAUsages",
    "ATTm590521": "cACertificateDN",
    "ATTm590525": "dhcpIdentification",
    "ATTm590526": "dhcpObjName",
    "ATTm590527": "dhcpObjDescription",
    "ATTm590535": "superScopeDescription",
    "ATTm590536": "optionDescription",
    "ATTm590545": "ipPhone",
    "ATTm590546": "otherIpPhone",
    "ATTm590572": "ATTributeDisplayNames",
    "ATTm590573": "url",
    "ATTm590575": "userSharedFolder",
    "ATTm590576": "userSharedFolderOther",
    "ATTm590580": "aCSTimeOfDay",
    "ATTm590595": "servicePrincipalName",
    "ATTm590596": "aCSPolicyName",
    "ATTm590597": "aCSRSVPLogFilesLocation",
    "ATTm590608": "aCSIdentityName",
    "ATTm590610": "mailAddress",
    "ATTm590613": "transportDLLName",
    "ATTm590633": "remoteStorageGUID",
    "ATTm590634": "createDialog",
    "ATTm590636": "createWizardExt",
    "ATTm590639": "canUpgradeScript",
    "ATTm590640": "fileExtPriority",
    "ATTm590641": "localizedDescription",
    "ATTm590647": "certificateTemplates",
    "ATTm590648": "signatureAlgorithms",
    "ATTm590649": "enrollmentProviders",
    "ATTm590667": "lDAPAdminLimits",
    "ATTm590669": "msiScriptName",
    "ATTm590679": "netbootNewMachineNamingPolicy",
    "ATTm590681": "netbootIntelliMirrorOSes",
    "ATTm590682": "netbootTools",
    "ATTm590683": "netbootLocallyInstalledOSes",
    "ATTm590691": "altSecurityIdentities",
    "ATTm590695": "fRSControlDataCreation",
    "ATTm590696": "fRSControlInboundBacklog",
    "ATTm590697": "fRSControlOutboundBacklog",
    "ATTm590703": "fRSServiceCommandStatus",
    "ATTm590706": "fRSVersion",
    "ATTm590707": "msRRASVendorAttributeEntry",
    "ATTm590708": "msRRASAttribute",
    "ATTm590710": "purportedSearch",
    "ATTm590711": "iPSECNegotiationPolicyType",
    "ATTm590712": "iPSECNegotiationPolicyAction",
    "ATTm590713": "additionalTrustedServiceNames",
    "ATTm590714": "uPNSuffixes",
    "ATTm590715": "gPLink",
    "ATTm590718": "gPCFileSysPath",
    "ATTm590724": "aCSRSVPAccountFilesLocation",
    "ATTm591033": "shortServerName",
    "ATTm591064": "netbootSIFFile",
    "ATTm591065": "netbootMirrorDataFile",
    "ATTm591067": "mSMQQueueNameExt",
    "ATTm591131": "accountNameHistory",
    "ATTm591136": "aCSServerList",
    "ATTm591154": "pKICriticalExtensions",
    "ATTm591157": "pKIExtendedKeyUsage",
    "ATTm591158": "pKIDefaultCSPs",
    "ATTm591167": "dSUIAdminNotification",
    "ATTm591171": "sPNMappings",
    "ATTm591172": "gPCMachineExtensionNames",
    "ATTm591173": "gPCUserExtensionNames",
    "ATTm591179": "queryFilter",
    "ATTm591187": "mS-SQL-Name",
    "ATTm591188": "mS-SQL-RegisteredOwner",
    "ATTm591189": "mS-SQL-Contact",
    "ATTm591190": "mS-SQL-Location",
    "ATTm591193": "mS-SQL-ServiceAccount",
    "ATTm591195": "mS-SQL-SortOrder",
    "ATTm591198": "mS-SQL-NamedPipe",
    "ATTm591199": "mS-SQL-MultiProtocol",
    "ATTm591200": "mS-SQL-SPX",
    "ATTm591201": "mS-SQL-TCPIP",
    "ATTm591202": "mS-SQL-AppleTalk",
    "ATTm591203": "mS-SQL-Vines",
    "ATTm591205": "mS-SQL-LastUpdatedDate",
    "ATTm591206": "mS-SQL-InformationURL",
    "ATTm591207": "mS-SQL-ConnectionURL",
    "ATTm591208": "mS-SQL-PublicationURL",
    "ATTm591209": "mS-SQL-GPSLatitude",
    "ATTm591210": "mS-SQL-GPSLongitude",
    "ATTm591211": "mS-SQL-GPSHeight",
    "ATTm591212": "mS-SQL-Version",
    "ATTm591213": "mS-SQL-Language",
    "ATTm591214": "mS-SQL-Description",
    "ATTm591215": "mS-SQL-Type",
    "ATTm591217": "mS-SQL-Database",
    "ATTm591219": "mS-SQL-Alias",
    "ATTm591221": "mS-SQL-CreationDate",
    "ATTm591222": "mS-SQL-LastBackupDate",
    "ATTm591223": "mS-SQL-LastDiagnosticDate",
    "ATTm591224": "mS-SQL-Applications",
    "ATTm591225": "mS-SQL-Keywords",
    "ATTm591226": "mS-SQL-Publisher",
    "ATTm591239": "mSMQLabelEx",
    "ATTm591240": "mSMQSiteNameEx",
    "ATTm591241": "mSMQComputerTypeEx",
    "ATTm591260": "msPKI-Cert-Template-OID",
    "ATTm591261": "msPKI-Supersede-Templates",
    "ATTm591262": "msPKI-RA-Policies",
    "ATTm591263": "msPKI-Certificate-Policy",
    "ATTm591445": "msDS-Other-Settings",
    "ATTm591447": "msWMI-Author",
    "ATTm591448": "msWMI-ChangeDate",
    "ATTm591449": "msWMI-ClassDefinition",
    "ATTm591450": "msWMI-CreationDate",
    "ATTm591451": "msWMI-ID",
    "ATTm591460": "msWMI-StringDefault",
    "ATTm591461": "msWMI-StringValidValues",
    "ATTm591462": "msWMI-Mof",
    "ATTm591463": "msWMI-Name",
    "ATTm591464": "msWMI-NormalizedClass",
    "ATTm591465": "msWMI-PropertyName",
    "ATTm591466": "msWMI-Query",
    "ATTm591467": "msWMI-QueryLanguage",
    "ATTm591468": "msWMI-SourceOrganization",
    "ATTm591469": "msWMI-TargetClass",
    "ATTm591470": "msWMI-TargetNameSpace",
    "ATTm591472": "msWMI-TargetPath",
    "ATTm591473": "msWMI-TargetType",
    "ATTm591496": "msPKI-OID-CPS",
    "ATTm591497": "msPKI-OID-User-Notice",
    "ATTm591498": "msPKI-Certificate-Application-Policy",
    "ATTm591499": "msPKI-RA-Application-Policies",
    "ATTm591500": "msWMI-Class",
    "ATTm591506": "msWMI-Parm1",
    "ATTm591507": "msWMI-Parm2",
    "ATTm591508": "msWMI-Parm3",
    "ATTm591509": "msWMI-Parm4",
    "ATTm591510": "msWMI-ScopeGuid",
    "ATTm591511": "extraColumns",
    "ATTm591512": "msDS-Security-Group-Extra-Classes",
    "ATTm591513": "msDS-Non-Security-Group-Extra-Classes",
    "ATTm591514": "adminMultiselectPropertyPages",
    "ATTm591516": "msFRS-Topology-Pref",
    "ATTm591518": "gPCWQLFilter",
    "ATTm591519": "msMQ-Recipient-FormatName",
    "ATTm591521": "msDS-Settings",
    "ATTm591522": "msTAPI-uid",
    "ATTm591523": "msTAPI-ProtocolId",
    "ATTm591525": "msTAPI-IpAddress",
    "ATTm591527": "msDS-FilterContainers",
    "ATTm591534": "msDS-AllowedDNSSuffixes",
    "ATTm591536": "msPKI-OIDLocalizedName",
    "ATTm591538": "MSMQ-MulticastAddress",
    "ATTm591539": "msDS-SPNSuffixes",
    "ATTm591541": "msDS-AdditionalDnsHostName",
    "ATTm591542": "msDS-AdditionalSamAccountName",
    "ATTm591543": "msDS-DnsRootAlias",
    "ATTm591545": "msDS-UpdateScript",
    "ATTm591609": "msIIS-FTPRoot",
    "ATTm591610": "msIIS-FTPDir",
    "ATTm591611": "msDS-AllowedToDelegateTo",
    "ATTm591616": "msDS-AzLDAPQuery",
    "ATTm591622": "msDS-AzApplicationName",
    "ATTm591623": "msDS-AzScopeName",
    "ATTm591625": "msDS-AzBizRule",
    "ATTm591626": "msDS-AzBizRuleLanguage",
    "ATTm591627": "msDS-AzLastImportedBizRulePath",
    "ATTm591640": "msDS-AzClassId",
    "ATTm591641": "msDS-AzApplicationVersion",
    "ATTm591643": "msDS-AzApplicationData",
    "ATTm591647": "msieee80211-ID",
    "ATTm591657": "msDS-ExternalKey",
    "ATTm591658": "msDS-ExternalStore",
    "ATTm591703": "msDS-SourceObjectDN",
    "ATTm591766": "msDS-PhoneticFirstName",
    "ATTm591767": "msDS-PhoneticLastName",
    "ATTm591768": "msDS-PhoneticDepartment",
    "ATTm591769": "msDS-PhoneticCompanyName",
    "ATTm591770": "msDS-PhoneticDisplayName",
    "ATTm591774": "msDS-AzGenericData",
    "ATTm591775": "ms-net-ieee-80211-GP-PolicyGUID",
    "ATTm591776": "ms-net-ieee-80211-GP-PolicyData",
    "ATTm591778": "ms-net-ieee-8023-GP-PolicyGUID",
    "ATTm591779": "ms-net-ieee-8023-GP-PolicyData",
    "ATTm591786": "msDS-PromotionSettings",
    "ATTm591788": "msFVE-RecoveryPassword",
    "ATTm591790": "msTPM-OwnerInformation",
    "ATTm591800": "msTSProfilePath",
    "ATTm591801": "msTSHomeDirectory",
    "ATTm591802": "msTSHomeDrive",
    "ATTm591813": "msTSWorkDirectory",
    "ATTm591814": "msTSInitialProgram",
    "ATTm591815": "msTSProperty01",
    "ATTm591816": "msTSProperty02",
    "ATTm591818": "msTSLicenseVersion",
    "ATTm591819": "msTSManagingLS",
    "ATTm591825": "msTSLicenseVersion2",
    "ATTm591826": "msTSManagingLS2",
    "ATTm591828": "msTSLicenseVersion3",
    "ATTm591829": "msTSManagingLS3",
    "ATTm591831": "msTSLicenseVersion4",
    "ATTm591832": "msTSManagingLS4",
    "ATTm591833": "msTSLSProperty01",
    "ATTm591834": "msTSLSProperty02",
    "ATTm591860": "msDFS-Commentv2",
    "ATTm591861": "msDFS-Propertiesv2",
    "ATTm591863": "msDFS-LinkPathv2",
    "ATTm591866": "msDFS-ShortNameLinkPathv2",
    "ATTm591878": "msImaging-PSPString",
    "ATTm591891": "msDS-LastKnownRDN",
    "ATTm591894": "msTSEndpointData",
    "ATTm591896": "msTSEndpointPlugin",
    "ATTm591900": "msPKI-Enrollment-Servers",
    "ATTm591901": "msPKI-Site-Name",
    "ATTm591907": "msSPP-InstallationId",
    "ATTm591908": "msSPP-ConfirmationId",
    "ATTm591921": "msDS-ClaimPossibleValues",
    "ATTm591929": "msSPP-CSVLKPid",
    "ATTm591930": "msSPP-CSVLKPartialProductKey",
    "ATTm591932": "msTPM-OwnerInformationTemp",
    "ATTm591952": "msDNS-KeymasterZones",
    "ATTm591972": "msDNS-NSEC3UserSalt",
    "ATTm591973": "msDNS-NSEC3CurrentSalt",
    "ATTm591974": "msAuthz-EffectiveSecurityPolicy",
    "ATTm591975": "msAuthz-ProposedSecurityPolicy",
    "ATTm591976": "msAuthz-LastEffectiveSecurityPolicy",
    "ATTm591977": "msAuthz-ResourceCondition",
    "ATTm591981": "msDS-ClaimSource",
    "ATTm591982": "msDS-ClaimSourceType",
    "ATTm591993": "msKds-KDFAlgorithmID",
    "ATTm591995": "msKds-SecretAgreementAlgorithmID",
    "ATTm592005": "msImaging-HashAlgorithm",
    "ATTm592013": "msDS-TransformationRules",
    "ATTm592019": "msDS-AppliesToResourceTypes",
    "ATTm592038": "msDS-cloudExtensionAttribute1",
    "ATTm592039": "msDS-cloudExtensionAttribute2",
    "ATTm592040": "msDS-cloudExtensionAttribute3",
    "ATTm592041": "msDS-cloudExtensionAttribute4",
    "ATTm592042": "msDS-cloudExtensionAttribute5",
    "ATTm592043": "msDS-cloudExtensionAttribute6",
    "ATTm592044": "msDS-cloudExtensionAttribute7",
    "ATTm592045": "msDS-cloudExtensionAttribute8",
    "ATTm592046": "msDS-cloudExtensionAttribute9",
    "ATTm592047": "msDS-cloudExtensionAttribute10",
    "ATTm592048": "msDS-cloudExtensionAttribute11",
    "ATTm592049": "msDS-cloudExtensionAttribute12",
    "ATTm592050": "msDS-cloudExtensionAttribute13",
    "ATTm592051": "msDS-cloudExtensionAttribute14",
    "ATTm592052": "msDS-cloudExtensionAttribute15",
    "ATTm592053": "msDS-cloudExtensionAttribute16",
    "ATTm592054": "msDS-cloudExtensionAttribute17",
    "ATTm592055": "msDS-cloudExtensionAttribute18",
    "ATTm592056": "msDS-cloudExtensionAttribute19",
    "ATTm592057": "msDS-cloudExtensionAttribute20",
    "ATTm592073": "msDS-DeviceOSType",
    "ATTm592074": "msDS-DeviceOSVersion",
    "ATTm592075": "msDS-DevicePhysicalIDs",
    "ATTm592089": "msDS-DrsFarmID",
    "ATTm592100": "msDS-SyncServerUrl",
    "ATTm592132": "msDS-DeviceMDMStatus",
    "ATTm592134": "msDS-ExternalDirectoryObjectId",
    "ATTm592141": "msDS-KeyUsage",
    "ATTm592144": "msDS-DeviceDN",
    "ATTm592176": "msDS-SourceAnchor",
    "ATTm592177": "msDS-ObjectSoa",
    "ATTm592190": "msDS-preferredDataLocation",
    "ATTm6": "c",
    "ATTm7": "l",
    "ATTm8": "st",
    "ATTm9": "street",
    "ATTn29": "presentationAddress",
    "ATTp131353": "nTSecurityDescriptor",
    "ATTp590359": "fRSRootSecurity",
    "ATTp591159": "pKIEnrollmentAccess",
    "ATTp591864": "msDFS-LinkSecurityDescriptorv2",
    "ATTp592006": "msDS-AllowedToActOnBehalfOfOtherIdentity",
    "ATTp592024": "msDS-GroupMSAMembership",
    "ATTq131091": "uSNCreated",
    "ATTq131192": "uSNChanged",
    "ATTq131193": "uSNLastObjRem",
    "ATTq131339": "uSNDSALastObjRemoved",
    "ATTq2293764": "msDFSR-RootSizeInMb",
    "ATTq2293766": "msDFSR-StagingSizeInMb",
    "ATTq2293768": "msDFSR-ConflictSizeInMb",
    "ATTq2293780": "msDFSR-RdcMinFileSizeInKb",
    "ATTq2293787": "msDFSR-DeletedSizeInMb",
    "ATTq2293799": "msDFSR-CommonStagingSizeInMb",
    "ATTq589837": "builtinCreationTime",
    "ATTq589838": "builtinModifiedCount",
    "ATTq589850": "creationTime",
    "ATTq589863": "forceLogoff",
    "ATTq589873": "badPasswordTime",
    "ATTq589874": "lastContentIndexed",
    "ATTq589875": "lastLogoff",
    "ATTq589876": "lastLogon",
    "ATTq589877": "lastSetTime",
    "ATTq589884": "lockoutDuration",
    "ATTq589885": "lockOutObservationWindow",
    "ATTq589890": "lSACreationTime",
    "ATTq589891": "lSAModifiedCount",
    "ATTq589898": "maxPwdAge",
    "ATTq589899": "maxRenewAge",
    "ATTq589900": "maxStorage",
    "ATTq589901": "maxTicketAge",
    "ATTq589902": "minPwdAge",
    "ATTq589904": "minTicketAge",
    "ATTq589905": "modifiedCountAtLastProm",
    "ATTq589920": "pwdLastSet",
    "ATTq589923": "priorSetTime",
    "ATTq589927": "proxyLifetime",
    "ATTq589983": "accountExpires",
    "ATTq589992": "modifiedCount",
    "ATTq590194": "rIDAvailablePool",
    "ATTq590195": "rIDAllocationPool",
    "ATTq590196": "rIDPreviousAllocationPool",
    "ATTq590197": "rIDUsedPool",
    "ATTq590326": "timeVolChange",
    "ATTq590327": "timeRefresh",
    "ATTq590343": "lastBackupRestorationTime",
    "ATTq590344": "machinePasswordChangeInterval",
    "ATTq590459": "privilegeValue",
    "ATTq590486": "lockoutTime",
    "ATTq590522": "dhcpUniqueKey",
    "ATTq590524": "dhcpFlags",
    "ATTq590543": "dhcpMaxKey",
    "ATTq590544": "dhcpUpdateTime",
    "ATTq590582": "aCSMaxTokenRatePerFlow",
    "ATTq590583": "aCSMaxPeakBandwidthPerFlow",
    "ATTq590584": "aCSAggregateTokenRatePerUser",
    "ATTq590589": "aCSPermissionBits",
    "ATTq590590": "aCSAllocableRSVPBandwidth",
    "ATTq590591": "aCSMaxPeakBandwidth",
    "ATTq590604": "aCSNonReservedTxLimit",
    "ATTq590690": "pekKeyChangeInterval",
    "ATTq590720": "uSNSource",
    "ATTq590721": "aCSMaxAggregatePeakRatePerUser",
    "ATTq590722": "aCSNonReservedTxSize",
    "ATTq591137": "aCSMaxTokenBucketPerFlow",
    "ATTq591138": "aCSMaximumSDUSize",
    "ATTq591139": "aCSMinimumPolicedSize",
    "ATTq591140": "aCSMinimumLatency",
    "ATTq591141": "aCSMinimumDelayVariation",
    "ATTq591142": "aCSNonReservedPeakRate",
    "ATTq591143": "aCSNonReservedTokenSize",
    "ATTq591144": "aCSNonReservedMaxSDUSize",
    "ATTq591145": "aCSNonReservedMinPolicedSize",
    "ATTq591191": "mS-SQL-Memory",
    "ATTq591204": "mS-SQL-Status",
    "ATTq591220": "mS-SQL-Size",
    "ATTq591266": "msDS-Cached-Membership-Time-Stamp",
    "ATTq591456": "msWMI-Int8Default",
    "ATTq591457": "msWMI-Int8Max",
    "ATTq591458": "msWMI-Int8Min",
    "ATTq591459": "msWMI-Int8ValidValues",
    "ATTq591520": "lastLogonTimestamp",
    "ATTq591794": "msDS-LastSuccessfulInteractiveLogonTime",
    "ATTq591795": "msDS-LastFailedInteractiveLogonTime",
    "ATTq591835": "msDS-MaximumPasswordAge",
    "ATTq591836": "msDS-MinimumPasswordAge",
    "ATTq591841": "msDS-LockoutObservationWindow",
    "ATTq591842": "msDS-LockoutDuration",
    "ATTq591879": "msDS-USNLastSyncSuccess",
    "ATTq591922": "msDS-ClaimValueType",
    "ATTq592002": "msKds-UseStartTime",
    "ATTq592003": "msKds-CreateTime",
    "ATTq592007": "msDS-GeoCoordinatesAltitude",
    "ATTq592008": "msDS-GeoCoordinatesLatitude",
    "ATTq592009": "msDS-GeoCoordinatesLongitude",
    "ATTq592086": "msDS-ApproximateLastLogonTimeStamp",
    "ATTq592103": "msDS-UserTGTLifetime",
    "ATTq592105": "msDS-ComputerTGTLifetime",
    "ATTq592108": "msDS-ServiceTGTLifetime",
    "ATTq592147": "msDS-KeyApproximateLastLogonTimeStamp",
    "ATTr589945": "securityIdentifier",
    "ATTr589970": "objectSid",
    "ATTr590433": "sIDHistory",
    "ATTr590491": "syncWithSID",
    "ATTr591234": "mS-DS-CreatorSID",
    "ATTr591668": "msDS-QuotaTrustee",
    "ATTr591978": "msAuthz-CentralAccessPolicyID",
    "ATTr592145": "msDS-ComputerSID",
    "ATTr592148": "msDS-ShadowPrincipalSid",
}
